import { DI } from '@microsoft/fast-foundation';
class DefaultJSONSerializer {
    constructor() {
        this.serialize = (object) => JSON.stringify(object);
    }
    deserialize(input) {
        if (input && input.ok) {
            return input.text().then((text) => JSON.parse(text));
        }
        if (input && input.data) {
            input = input.data;
        }
        return JSON.parse(input);
    }
}
export const JSONSerializer = DI.createInterface((x) => x.singleton(DefaultJSONSerializer));
//# sourceMappingURL=json.js.map