import { logger } from '../utils/logger';
export const insertDocumentCSSRule = (cssRule, styleElementId) => {
    var _a;
    let styleElement = document.getElementById(styleElementId);
    if (styleElement) {
        logger.debug(`
      An element with the id of '${styleElementId}' already exists and likely has the css rules applied.
    `);
        return;
    }
    const headElement = (_a = document.head) !== null && _a !== void 0 ? _a : document.getElementsByTagName('head')[0];
    styleElement = document.createElement('style');
    styleElement.id = styleElementId;
    headElement.appendChild(styleElement);
    const styleIndex = styleElement.sheet.insertRule(cssRule);
    return () => {
        if (!styleElement) {
            return;
        }
        styleElement.sheet.deleteRule(styleIndex);
        headElement.removeChild(styleElement);
    };
};
export const insertDocumentLink = (href) => {
    const links = document.head.querySelectorAll('link');
    for (const index in links)
        if (links[index].href === href)
            return;
    const link = document.createElement('link');
    link.rel = 'stylesheet';
    link.href = href;
    document.head.appendChild(link);
};
//# sourceMappingURL=dom.js.map