import { __awaiter } from "tslib";
import { v4 as uuidv4 } from 'uuid';
import { DI } from '@microsoft/fast-foundation';
import { logger } from '../utils';
class UUIDService {
    constructor() { }
    createId(withLogging = false) {
        const id = uuidv4();
        withLogging && logger.debug(`UUID.createID ${id}`);
        return id;
    }
    createRemoteId(withLogging = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = uuidv4();
            withLogging && logger.debug(`UUID.createRemoteID ${id}`);
            return id;
        });
    }
}
export const UUID = DI.createInterface((x) => x.singleton(UUIDService));
//# sourceMappingURL=uuid.js.map