export const inIFrame = () => {
    try {
        return window.self !== window.top;
    }
    catch (e) {
        return true;
    }
};
export const inSymphonyDesktop = () => {
    const userAgent = navigator === null || navigator === void 0 ? void 0 : navigator.userAgent;
    return (userAgent === null || userAgent === void 0 ? void 0 : userAgent.includes('Symphony')) && (userAgent === null || userAgent === void 0 ? void 0 : userAgent.includes('Electron'));
};
export const POPUP_DEFAULT_WIDTH = 483;
export const POPUP_DEFAULT_HEIGHT = 600;
export const openPopup = (urlNavigate, target, popUpWidth = POPUP_DEFAULT_WIDTH, popUpHeight = POPUP_DEFAULT_HEIGHT) => {
    const left = window.innerWidth / 2 - popUpWidth / 2 + window.screenX;
    const top = window.innerHeight / 2 - popUpHeight / 2 + window.screenY;
    const popupWindow = window.open(urlNavigate, target, 'width=' +
        popUpWidth +
        ', height=' +
        popUpHeight +
        ', top=' +
        top +
        ', left=' +
        left +
        ', scrollbars=yes');
    if (popupWindow.focus) {
        popupWindow.focus();
    }
    return popupWindow;
};
//# sourceMappingURL=window.js.map